      subroutine prompt2(header,density,
     $     focallength,infilename,bhimaglim,blomaglim,
     $     rhimaglim,rlomaglim,ihimaglim,ilomaglim,outstyle,
     $     outfilename,batch,pixelsize,ascending,sortfield,
     $     catmap,ra,spd,rahalf,spdhalf,error)
C
C $Id: prompt2.f,v 1.2 1997/01/09 19:13:28 koehn Exp $
      implicit none
      include 'std_io.f'
      include 'include_starnet.f'
      integer batch,lnblnk
      logical header,ascending,error,done
      real*8 density,focallength,bhimaglim,blomaglim,rhimaglim,
     $     rlomaglim,ihimaglim,ilomaglim,pixelsize,temp,ra,spd,
     $     rahalf,spdhalf
      character*64 infilename,outfilename,catmap,dummy,left_justify,
     $     downcase_str
      character*1 outstyle,sortfield
C     
C     Get aperture width
C     
      write(stdout,20,err=402)
 20   format(' ')
      write(stdout,21,err=402)
 21   format(' Starnet - Star Catalog Access')
      write(stdout,20,err=402)
      write(stdout,22,err=402)
 22   format(' Default values in square brackets. ',
     $     'Depress RETURN to accept.')
      write(stdout,20,err=402)
      done=.false.
      do while (.not. done)
         write(stdout,1,err=402) 3600.0d0*2.0d0*rahalf/pio180
 1       format(' Aperture (RA) width (arcsec) (0 to quit):[',
     $        f8.1,']',$)
         read(stdin,2,err=401) dummy
 2       format(a64)
         if (dummy .eq. ' ') then
            temp=3600.0d0*2.0d0*rahalf/pio180
         else
            call str2r8(dummy,temp,error)
         end if
         if (.not. error) then
            temp=pio180*temp/7200.0d0
            if ((temp .ge. 0.0d0) .and. (temp .le. pi/4.0d0)) then
               rahalf=temp
               done=.true.
            else
               call stat_msg('prompt2',
     $              'Aperture width must lie between '//
     $              '0 and 324000 arcsec')
            end if
         else
            error=.false.
            call stat_msg('prompt2',
     $           'Unable to convert characters into a number.')
            call stat_msg('prompt2',
     $           'Please enter the width as decimal digits.')
         end if
      end do
      if (rahalf .ne. 0.0d0) then
C     
C     Get aperture height
C     
         done=.false.
         do while (.not. done)
            write(stdout,3,err=402) 3600.0d0*2.0d0*spdhalf/pio180
 3          format(' Aperture (Decl.) height (arcsec):[',f8.1,']',$)
            read(stdin,2,err=401) dummy
            if (dummy .eq. ' ') then
               temp=3600.0d0*2.0d0*spdhalf/pio180
            else
               call str2r8(dummy,temp,error)
            end if
            if (.not. error) then
               temp=pio180*temp/7200.0d0
               if ((temp .ge. 0.0d0) .and. (temp .le. pi/4.0d0)) then
                  spdhalf=temp
                  done=.true.
               else
                  call stat_msg('prompt2',
     $                 'Aperture height must lie between '//
     $                 '0 and 324000 arcsec')
               end if
            else
               error=.false.
               call stat_msg('prompt2',
     $              'Unable to convert characters into a number.')
               call stat_msg('prompt2',
     $              'Please enter the height as decimal digits.')
            end if
         end do
C     
C     Get RA of aperture center
C     
         done=.false.
         do while (.not. done)
            call rad2hms(ra,dummy)
            write(stdout,4,err=402) dummy
 4          format(' Aperture center (RA) (hr min sec):[',
     $           a13,']',$)
            read(stdin,2,err=401) dummy
            if (dummy .eq. ' ') then
               temp=ra
            else
               call hms2rad(dummy,temp,error)
            end if
            if (.not. error) then
               if ((temp .ge. 0.0d0) .and. (temp .le. twopi)) then
                  ra=temp
                  done=.true.
               else
                  call stat_msg('prompt2',
     $                 'RA must lie between '//
     $                 '0 and 24 hours')
               end if
            else
               error=.false.
               call stat_msg('prompt2',
     $              'Unable to convert characters into a RA.')
               call stat_msg('prompt2',
     $              'Please enter the RA as three sets of '//
     $              'decimal digits.')
            end if
         end do
C     
C     Get Decl. of aperture center
C     
         done=.false.
         do while (.not. done)
            call rad2dms(spd,dummy)
            write(stdout,5,err=402) dummy
 5          format(' Aperture center (Decl.) (deg min sec):[',
     $           a12,']',$)
            read(stdin,2,err=401) dummy
            if (dummy .eq. ' ') then
               temp=spd
            else
               call dms2rad(dummy,temp,error)
            end if
            if (.not. error) then
               if ((temp .ge. 0.0d0) .and. (temp .le. pi)) then
                  spd=temp
                  done=.true.
               else
                  call stat_msg('prompt2',
     $                 'Decl. must lie between '//
     $                 '-90 and 90 deg.')
               end if
            else
               error=.false.
               call stat_msg('prompt2',
     $              'Unable to convert characters into a number.')
               call stat_msg('prompt2',
     $              'Please enter the decl. as three '//
     $              'sets of decimal digits.')
            end if
         end do
C     
C     Get red magnitude low limit
C     
         done=.false.
         do while (.not. done)
            write(stdout,6,err=402) rlomaglim
 6          format(' Red mag low (bright) limit (mag):[',f5.1,']',$)
            read(stdin,2,err=401) dummy
            if (dummy .eq. ' ') then
               temp=rlomaglim
            else
               call str2r8(dummy,temp,error)
            end if
            if (.not. error) then
               if ((temp .ge. -5.0d0) .and. (temp .le. 30.0d0)) then
                  rlomaglim=temp
                  done=.true.
               else
                  call stat_msg('prompt2',
     $                 'The red low magnitude limit must '//
     $                 'lie between -5 and 30')
               end if
            else
               error=.false.
               call stat_msg('prompt2',
     $              'Unable to convert characters into a number.')
               call stat_msg('prompt2',
     $              'Please enter the magnitude as decimal digits.')
            end if
         end do
C     
C     Get red magnitude high limit
C     
         done=.false.
         do while (.not. done)
            write(stdout,7,err=402) rhimaglim
 7          format(' Red mag high (dim) limit (mag):[',f5.1,']',$)
            read(stdin,2,err=401) dummy
            if (dummy .eq. ' ') then
               temp=rhimaglim
            else
               call str2r8(dummy,temp,error)
            end if
            if (.not. error) then
               if ((temp .ge. -5.0d0) .and. (temp .le. 30.0d0)
     $              .and. (temp .gt. rlomaglim)) then
                  rhimaglim=temp
                  done=.true.
               else
                  call stat_msg('prompt2',
     $                 'The red high magnitude limit must '//
     $                 'lie between -5 and 30 and '//
     $                 'it must be greater than the low limit.')
               end if
            else
               error=.false.
               call stat_msg('prompt2',
     $              'Unable to convert characters into a number.')
               call stat_msg('prompt2',
     $              'Please enter the magnitude as decimal digits.')
            end if
         end do
C     
C     Get blue magnitude low limit
C     
         done=.false.
         do while (.not. done)
            write(stdout,8,err=402) blomaglim
 8          format(' Blue mag low (bright) limit (mag):[',f5.1,']',$)
            read(stdin,2,err=401) dummy
            if (dummy .eq. ' ') then
               temp=blomaglim
            else
               call str2r8(dummy,temp,error)
            end if
            if (.not. error) then
               if ((temp .ge. -5.0d0) .and. (temp .le. 30.0d0)) then
                  blomaglim=temp
                  done=.true.
               else
                  call stat_msg('prompt2',
     $                 'The Blue low magnitude limit must '//
     $                 'lie between -5 and 30')
               end if
            else
               error=.false.
               call stat_msg('prompt2',
     $              'Unable to convert characters into a number.')
               call stat_msg('prompt2',
     $              'Please enter the magnitude as decimal digits.')
            end if
         end do
C     
C     Get blue magnitude high limit
C     
         done=.false.
         do while (.not. done)
            write(stdout,9,err=402) bhimaglim
 9          format(' Blue mag high (dim) limit (mag):[',f5.1,']',$)
            read(stdin,2,err=401) dummy
            if (dummy .eq. ' ') then
               temp=bhimaglim
            else
               call str2r8(dummy,temp,error)
            end if
            if (.not. error) then
               if ((temp .ge. -5.0d0) .and. (temp .le. 30.0d0)
     $              .and. (temp .gt. blomaglim)) then
                  bhimaglim=temp
                  done=.true.
               else
                  call stat_msg('prompt2',
     $                 'The Blue high magnitude limit must '//
     $                 'lie between -5 and 30 and '//
     $                 'it must be greater than the low limit.')
               end if
            else
               error=.false.
               call stat_msg('prompt2',
     $              'Unable to convert characters into a number.')
               call stat_msg('prompt2',
     $              'Please enter the magnitude as decimal digits.')
            end if
         end do
C     
C     Get color index  magnitude low limit
C     
         done=.false.
         do while (.not. done)
            write(stdout,10,err=402) ilomaglim
 10         format(' Index mag low (bright) limit (mag):[',f5.1,']',$)
            read(stdin,2,err=401) dummy
            if (dummy .eq. ' ') then
               temp=ilomaglim
            else
               call str2r8(dummy,temp,error)
            end if
            if (.not. error) then
               if ((temp .ge. -5.0d0) .and. (temp .le. 30.0d0)) then
                  ilomaglim=temp
                  done=.true.
               else
                  call stat_msg('prompt2',
     $                 'The index low magnitude limit must '//
     $                 'lie between -5 and 30')
               end if
            else
               error=.false.
               call stat_msg('prompt2',
     $              'Unable to convert characters into a number.')
               call stat_msg('prompt2',
     $              'Please enter the magnitude as decimal digits.')
            end if
         end do
C     
C     Get color index magnitude high limit
C     
         done=.false.
         do while (.not. done)
            write(stdout,11,err=402) ihimaglim
 11         format(' Index mag high (dim) limit (mag):[',f5.1,']',$)
            read(stdin,2,err=401) dummy
            if (dummy .eq. ' ') then
               temp=ihimaglim
            else
               call str2r8(dummy,temp,error)
            end if
            if (.not. error) then
               if ((temp .ge. -5.0d0) .and. (temp .le. 30.0d0)
     $              .and. (temp .gt. ilomaglim)) then
                  ihimaglim=temp
                  done=.true.
               else
                  call stat_msg('prompt2',
     $                 'The index high magnitude limit must '//
     $                 'lie between -5 and 30 and '//
     $                 'it must be greater than the low limit.')
               end if
            else
               error=.false.
               call stat_msg('prompt2',
     $              'Unable to convert characters into a number.')
               call stat_msg('prompt2',
     $              'Please enter the magnitude as decimal digits.')
            end if
         end do
C     
C     Get star density
C     
         done=.false.
         do while (.not. done)
            write(stdout,12,err=402) density
 12         format(' Star density (stars/sq.deg.):[',f13.1,']',$)
            read(stdin,2,err=401) dummy
            if (dummy .eq. ' ') then
               temp=density
            else
               call str2r8(dummy,temp,error)
            end if
            if (.not. error) then
               if (temp .ge. 0.0d0) then
                  density=temp
                  done=.true.
               else
                  call stat_msg('prompt2',
     $                 'Density must be greater than '//
     $                 '0.')
               end if
            else
               error=.false.
               call stat_msg('prompt2',
     $              'Unable to convert characters into a number.')
               call stat_msg('prompt2',
     $              'Please enter the density as decimal digits.')
            end if
         end do
C     
C     Get output file name
C     
         if (outfilename .eq. ' ') then
            dummy='-'
         else
            dummy=outfilename
         end if
         write(stdout,13,err=402) dummy(1:lnblnk(dummy))
 13      format(' Output file name (''-'' for terminal):[',
     $        a,']',$)
         read(stdin,2,err=401) dummy
         if (dummy .eq. ' ') then
         elseif (dummy .eq. '-') then
            outfilename=' '
         else
            outfilename=dummy
         end if
C     
C     Get output style
C     
         done=.false.
         do while (.not. done)
            if (outstyle .eq. 'a') then
               dummy='ascii'
            elseif (outstyle .eq. 'i') then
               dummy='iraf'
            elseif (outstyle .eq. 'c') then
               dummy='catalog'
            end if
            write(stdout,14,err=402) dummy(1:lnblnk(dummy))
 14         format(' Output style (ascii | catalog | iraf):[',
     $           a,']',$)
            read(stdin,2,err=401) dummy
            dummy=downcase_str(left_justify(dummy))
            if (dummy .eq. ' ') then
               done=.true.
            elseif (dummy(1:1) .eq. 'a') then
               outstyle='a'
               done=.true.
            elseif (dummy(1:1) .eq. 'c') then
               outstyle='c'
               done=.true.
            elseif (dummy(1:1) .eq. 'i') then
               outstyle='i'
               done=.true.
            else
               call stat_msg('prompt2',
     $              'Output style must be ascii, catalog or '//
     $              'iraf.')
            end if
         end do
         if (outstyle .eq. 'i') then
C     
C     Get focal length
C     
            done=.false.
            do while (.not. done)
               write(stdout,15,err=402) focallength
 15            format(' Focal length (meters):[',f6.3,']',$)
               read(stdin,2,err=401) dummy
               if (dummy .eq. ' ') then
                  temp=focallength
               else
                  call str2r8(dummy,temp,error)
               end if
               if (.not. error) then
                  if (temp .ge. 0.0d0)  then
                     focallength=temp
                     done=.true.
                  else
                     call stat_msg('prompt2',
     $                    'Focal length must be greater than zero.')
                  end if
               else
                  error=.false.
                  call stat_msg('prompt2',
     $                 'Unable to convert characters into a number.')
                  call stat_msg('prompt2',
     $                 'Please enter the focal length '//
     $                 'as decimal digits.')
               end if
            end do
C     
C     Get pixel size
C     
            done=.false.
            do while (.not. done)
               write(stdout,16,err=402) pixelsize*1.0d6
 16            format(' Pixel size (microns):[',
     $              f6.2,']',$)
               read(stdin,2,err=401) dummy
               if (dummy .eq. ' ') then
                  temp=pixelsize*1.0d6
               else
                  call str2r8(dummy,temp,error)
               end if
               if (.not. error) then
                  if (temp .ge. 0.0d0) then
                     pixelsize=temp*1.0d-6
                     done=.true.
                  else
                     call stat_msg('prompt2',
     $                    'Pixel size must be greater than zero.')
                  end if
               else
                  error=.false.
                  call stat_msg('prompt2',
     $                 'Unable to convert characters into a number.')
                  call stat_msg('prompt2',
     $                 'Please enter the pixel size as '//
     $                 'decimal digits.')
               end if
            end do            
         end if
C     
C     Get catalog map file name
C     
         write(stdout,17,err=402) catmap(1:lnblnk(catmap))
 17      format(' Catalog map file name:[',a,']',$)
         read(stdin,2,err=401) dummy
         if (dummy .eq. ' ') then
         else
            catmap=dummy
         end if
C     
C     Get sorting parameter
C     
         done=.false.
         do while (.not. done)
            if (sortfield .eq. 'R') then
               dummy='RA'
            elseif (sortfield .eq. 'D') then
               dummy='Decl'
            elseif (sortfield .eq. 'd') then
               dummy='angle'
            elseif (sortfield .eq. 'r') then
               dummy='radius'
            elseif (sortfield .eq. 'b') then
               dummy='blue'
            elseif (sortfield .eq. 'i') then
               dummy='red'
            elseif (sortfield .eq. 'a') then
               dummy='index'
            end if
            write(stdout,18,err=402) dummy(1:lnblnk(dummy))
 18         format(' Sort by (RA | Decl | angle | ',
     $           'radius | blue | red | index):[',a,']',$)
            read(stdin,2,err=401) dummy
            if (dummy .eq. ' ') then
               done=.true.
            else if (dummy .eq. 'RA') then
               sortfield='R'
               done=.true.
            else if (dummy .eq. 'Decl') then
               sortfield='D'
               done=.true.
            else if (dummy .eq. 'radius') then
               sortfield='d'
               done=.true.
            else if (dummy .eq. 'blue') then
               sortfield='b'
               done=.true.
            else if (dummy .eq. 'red') then
               sortfield='r'
               done=.true.
            else if (dummy .eq. 'index') then
               sortfield='i'
               done=.true.
            else if (dummy .eq. 'angle') then
               sortfield='a'
               done=.true.
            else
               call stat_msg('prompt2',
     $              'Sort fields must be RA, Decl, angle, '//
     $              'radius, blue, red, or index.')
            end if
         end do
C     
C     Get sorting direction
C     
         done=.false.
         do while (.not. done)
            if (ascending) then
               dummy='ascending'
            else
               dummy='descending'
            end if
            write(stdout,19,err=402) dummy(1:lnblnk(dummy))
 19         format(' Sort direction (ascending | descending):[',
     $           a,']',$)
            read(stdin,2,err=401) dummy
            if (dummy .eq. ' ') then
               done=.true.
            else
               if (dummy .eq. 'ascending') then
                  ascending=.true.
                  done=.true.
               elseif (dummy .eq. 'descending') then
                  ascending=.false.
                  done=.true.
               else
                  call stat_msg('prompt2',
     $                 'The sort direction must be '//
     $                 'ascending or descending.')
               end if
            end if
         end do
      end if
      goto 400
 401  error=.true.
      call err_msg('prompt2',
     $     'Error reading keyboard input.')
      goto 400
 402  error=.true.
      call err_msg('prompt2',
     $     'Error writing to terminal.')
 400  continue
      if (error) then
         call err_msg('prompt2','Traceback')
      end if
      return
      end
